--
-- fillsprayer
-- Specialization for fillsprayer
--
-- @author Felix "Outlaw" Sorge
-- @date  29/05/09
-- @web www.ls-modsource.de - www.ls-mods.de
--
-- Copyright (C) Outlaw, All Rights Reserved.
--


fillsprayer = {};

function fillsprayer.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function fillsprayer:load(xmlFile)

	
	self.dischargeSpeed = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.dischargeSpeed#value"), 1);
	end; 
	
end;



function fillsprayer:update(dt)

	if self.attacherVehicle then

		if InputBinding.hasEvent(InputBinding.fillsprayer_on) and self.CheckDone.transport and self.fillLevel ~= 0 and self.Go.transport then
			self.turnOn = not self.turnOn; 
			self.distanceCheck = not self.distanceCheck; 
		end; 
						

				
		if self.fillLevel == 0 then
		    if self.spraySoundEnabled then
		        stopSample(self.spraySound);
		        self.spraySoundEnabled = false;
			end;
			Utils.setEmittingState(self.dustParticleSystems, false)
			self.turnOn = false; 
		end; 
				
		if self.turnOn then
			
			local difficultyMultiplier = math.max(3 * (3 - g_currentMission.missionStats.difficulty), 1);
			local deltaLevel = FruitUtil.fruitIndexToDesc[self.currentFillType].literPerQm * difficultyMultiplier * self.dischargeSpeed;
			self:setFillLevel(self.fillLevel-deltaLevel, self.currentFillType);
			
			for k,cuttingArea in pairs(self.cuttingAreas) do
                local x,y,z = getWorldTranslation(cuttingArea.start);
                local x1,y1,z1 = getWorldTranslation(cuttingArea.width);
                local x2,y2,z2 = getWorldTranslation(cuttingArea.height);
                Utils.updateSprayArea(x, z, x1, z1, x2, z2);
            end;

				
		
		
	end; 	

	

function fillsprayer:draw()
end;


function fillsprayer:mouseEvent(posX, posY, isDown, isUp, button)
end;


function fillsprayer:keyEvent(unicode, sym, modifier, isDown)
end;


function fillsprayer:onAttach()
end; 	


function fillsprayer:onDetach()
end;


function fillsprayer:delete()
end;


function fillsprayer:getSaveAttributesAndNodes(nodeIdent)
end;


